program Priklad7;

type tIndex = (ix, iy, ivx, ivy);
     tPole = array[tIndex] of real;
     tProc = procedure( var dUdt : tPole; const U : tPole);

procedure EulerStep( Spocti_dUdt : tProc ; var U : tPole; var  t : real; const dt : real);
var    i : tIndex;
    dUdt : tPole;
begin
 Spocti_dUdt(dUdt,U);
 for i:=Low(U) to High(U) do U[i] := U[i] + dUdt[i]*dt;
 t := t+dt;
end;

procedure MidpointStep( Spocti_dUdt : tProc ; var U : tPole; var  t : real; const dt : real);
var    i : tIndex;
    dUdt : tPole;
    Upul : tPole;
begin
 Spocti_dUdt(dUdt,U);
 for i:=Low(U) to High(U) do Upul[i] := U[i] + dUdt[i]*dt*0.5;

 Spocti_dUdt(dUdt,Upul);
 for i:=Low(U) to High(U) do U[i] := U[i] + dUdt[i]*dt;
 t := t+dt;
end;

procedure PohyboveRovnicePlanety( var dVdt : tPole; const V : tPole);
const G = (4*Pi*Pi); // G v jednotkach AU,rok
var r,r3 : real;
begin
    r := sqrt(V[ix]*V[ix]+V[iy]*V[iy]);
    r3:= r*r*r;

    dVdt[ix] := V[ivx];
    dVdt[iy] := V[ivy];

    dVdt[ivx]:= -G*V[ix]/r3;
    dVdt[ivy]:= -G*V[iy]/r3;
end;

const dt=1/365.25;

var  t : real = 0;               // pocatecni cas
     V : tPole = (1,0,  0,2*Pi); // pocatecni rychlost Zeme je 2Pi AU/rok
     n : integer = 0;

begin

  while (t<1.2) do begin // 1.2 roku
    if n mod 10 = 0 then writeln(t,' ',V[ix],' ',V[iy]); // data pro trajektorii
    MidpointStep(PohyboveRovnicePlanety,V,t,dt);
    n   := n+1;
  end;

end.
